
import java.util.HashMap;
import java.util.Iterator;
import java.util.Collection;

/**
 * Classe entreprise : aucun héritage
 * @author blossier
 */
public class Entreprise {
    /** tableau des employés permettant la recherche par le nom,
     * L'ajout et le retrait efficace
     */
    HashMap<String, Employe> emp;
    /**
     * Le patron mis à part pour être affiché en premier et traité différement
     */
    Cadre patron;

    /// Constructeur
    public Entreprise(Cadre c) {
	this.patron = c;
	this.emp = new HashMap<String, Employe>();
    }

    /// ajout d'employé
    public void  ajouteEmploye(Employe e) throws Exception {
	// on vérifie si l'employé est  déjà dans cette entreprise 
        //et dans ce cas on lève une exception
	if (this.emp.containsValue(e.getNom())) throw new Exception(e+ 
                " est déjà dans l'entreprise.");
	this.emp.put(e.getNom(), e);
    }


    /// affiche
    public void affiche() {
	Iterator<Employe> it = this.emp.values().iterator();

	System.out.println(this.patron);
	while(it.hasNext()) {
	    System.out.println(it.next());
	}
    }

    ///Remarque : dans la méthode affiche, on peut remplacer l'utilisation 
    //de l'itérateur par une boucle sur une collection. Voir exemple ci-dessous : 
    public String toString() {
	String result = "Le patron "+this.patron+
                " a pour employés :\n";
	Collection<Employe> liste = emp.values();
	for (Employe e : liste) {
	    result = result+" - "+e+"\n";
	}
	return result;
    }

    public Employe rechercheParNom(String nom) throws Exception {
	// on verifie d'abors que ce n'est pas le patron
	if (this.patron.getNom().equals(nom)) {
	    return this.patron;
	} else {
	    // sinon on le recherche parmis les employes
	    Employe res = this.emp.get(nom);
	    if (res != null) {
		return res;
	    } else {
		throw new Exception("Le nom n'est pas bon");
	    }
	}
    }

    //Questions facultatives :
    public void retireEmploye(String nom) throws Exception {
	try {
	    Employe e = rechercheParNom(nom);
	    e.retireDeEntreprise(this);
	}
	catch (Exception excep) {
	    throw new Exception (nom+
                    " n'est pas ou plus un employé de cette entreprise.");
	}
    }
}
